// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:srv/ComputeGrasps.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/srv/compute_grasps.h"


#ifndef RC_REASON_MSGS__SRV__DETAIL__COMPUTE_GRASPS__STRUCT_H_
#define RC_REASON_MSGS__SRV__DETAIL__COMPUTE_GRASPS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'pose_frame'
// Member 'region_of_interest_id'
// Member 'load_carrier_id'
#include "rosidl_runtime_c/string.h"
// Member 'load_carrier_compartment'
#include "rc_reason_msgs/msg/detail/compartment__struct.h"
// Member 'item_models'
#include "rc_reason_msgs/msg/detail/item_model__struct.h"
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__struct.h"
// Member 'collision_detection'
#include "rc_reason_msgs/msg/detail/collision_detection__struct.h"

/// Struct defined in srv/ComputeGrasps in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__ComputeGrasps_Request
{
  /// Required. Pose frame for output poses (valid values are camera and external)
  rosidl_runtime_c__String pose_frame;
  /// Optional
  rosidl_runtime_c__String region_of_interest_id;
  /// Optional
  rosidl_runtime_c__String load_carrier_id;
  /// Optional
  rc_reason_msgs__msg__Compartment load_carrier_compartment;
  /// Optional. If empty, means one item of type unknown without dimensions
  rc_reason_msgs__msg__ItemModel__Sequence item_models;
  /// Required. Dimensions of the gripper suction surface
  /// In case of circular suction cups, the two values are expected to be the same and set to the suction cup diameter
  /// Different values are expected for grippers with multiple suction cups or non-circular suction cups (e.g. oval cups)
  double suction_surface_length;
  double suction_surface_width;
  /// Required only if reference frame = external and sensor is robot-mounted
  geometry_msgs__msg__Pose robot_pose;
  /// Optional. Enables collision checking of grasps with load carrier
  rc_reason_msgs__msg__CollisionDetection collision_detection;
} rc_reason_msgs__srv__ComputeGrasps_Request;

// Struct for a sequence of rc_reason_msgs__srv__ComputeGrasps_Request.
typedef struct rc_reason_msgs__srv__ComputeGrasps_Request__Sequence
{
  rc_reason_msgs__srv__ComputeGrasps_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__ComputeGrasps_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.h"
// Member 'items'
#include "rc_reason_msgs/msg/detail/item__struct.h"
// Member 'load_carriers'
#include "rc_reason_msgs/msg/detail/load_carrier__struct.h"
// Member 'grasps'
#include "rc_reason_msgs/msg/detail/suction_grasp__struct.h"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__struct.h"

/// Struct defined in srv/ComputeGrasps in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__ComputeGrasps_Response
{
  builtin_interfaces__msg__Time timestamp;
  rc_reason_msgs__msg__Item__Sequence items;
  rc_reason_msgs__msg__LoadCarrier__Sequence load_carriers;
  rc_reason_msgs__msg__SuctionGrasp__Sequence grasps;
  rc_common_msgs__msg__ReturnCode return_code;
} rc_reason_msgs__srv__ComputeGrasps_Response;

// Struct for a sequence of rc_reason_msgs__srv__ComputeGrasps_Response.
typedef struct rc_reason_msgs__srv__ComputeGrasps_Response__Sequence
{
  rc_reason_msgs__srv__ComputeGrasps_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__ComputeGrasps_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  rc_reason_msgs__srv__ComputeGrasps_Event__request__MAX_SIZE = 1
};
// response
enum
{
  rc_reason_msgs__srv__ComputeGrasps_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/ComputeGrasps in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__ComputeGrasps_Event
{
  service_msgs__msg__ServiceEventInfo info;
  rc_reason_msgs__srv__ComputeGrasps_Request__Sequence request;
  rc_reason_msgs__srv__ComputeGrasps_Response__Sequence response;
} rc_reason_msgs__srv__ComputeGrasps_Event;

// Struct for a sequence of rc_reason_msgs__srv__ComputeGrasps_Event.
typedef struct rc_reason_msgs__srv__ComputeGrasps_Event__Sequence
{
  rc_reason_msgs__srv__ComputeGrasps_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__ComputeGrasps_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__SRV__DETAIL__COMPUTE_GRASPS__STRUCT_H_
